<?php
/**
 * InlineResponse200
 *
 * PHP version 5
 *
 * @category Class
 * @package  Boxxai\Magic
 * @author   Swaagger Codegen team
 * @link     https://github.com/Boxx-api/Boxx-codegen
 */

/**
 * Recommendation API 2
 *
 * No description provided (generated by Boxx Codegen https://github.com/Boxx-api/Boxx-codegen)
 *
 * OpenAPI spec version: 1.5.0
 * 
 * Generated by: https://github.com/Boxx-api/Boxx-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the Boxx code generator program.
 * https://github.com/Boxx-api/Boxx-codegen
 * Do not edit the class manually.
 */

namespace Boxxai\Magic\Model;

use \ArrayAccess;

/**
 * InlineResponse200 Class Doc Comment
 *
 * @category    Class
 * @package     Boxxai\Magic
 * @author      Boxx Codegen team
 * @link        https://github.com/Boxx-api/Boxx-codegen
 */
class InlineResponse200 implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $BoxxModelName = 'inline_response_200';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $BoxxTypes = [
        'error_status' => 'bool',
        'result' => 'object',
        'request' => 'object'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $BoxxFormats = [
        'error_status' => null,
        'result' => null,
        'request' => null
    ];

    public static function BoxxTypes()
    {
        return self::$BoxxTypes;
    }

    public static function BoxxFormats()
    {
        return self::$BoxxFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'error_status' => 'error_status',
        'result' => 'result',
        'request' => 'request'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'error_status' => 'setErrorStatus',
        'result' => 'setResult',
        'request' => 'setRequest'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'error_status' => 'getErrorStatus',
        'result' => 'getResult',
        'request' => 'getRequest'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['error_status'] = isset($data['error_status']) ? $data['error_status'] : null;
        $this->container['result'] = isset($data['result']) ? $data['result'] : null;
        $this->container['request'] = isset($data['request']) ? $data['request'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        return true;
    }


    /**
     * Gets error_status
     * @return bool
     */
    public function getErrorStatus()
    {
        return $this->container['error_status'];
    }

    /**
     * Sets error_status
     * @param bool $error_status
     * @return $this
     */
    public function setErrorStatus($error_status)
    {
        $this->container['error_status'] = $error_status;

        return $this;
    }

    /**
     * Gets result
     * @return object
     */
    public function getResult()
    {
        return $this->container['result'];
    }

    /**
     * Sets result
     * @param object $result
     * @return $this
     */
    public function setResult($result)
    {
        $this->container['result'] = $result;

        return $this;
    }

    /**
     * Gets request
     * @return object
     */
    public function getRequest()
    {
        return $this->container['request'];
    }

    /**
     * Sets request
     * @param object $request
     * @return $this
     */
    public function setRequest($request)
    {
        $this->container['request'] = $request;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\Boxxai\Magic\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\Boxxai\Magic\ObjectSerializer::sanitizeForSerialization($this));
    }
}


